<?php

namespace Drupal\k8s\Service;

/**
 * K8sServiceRemote service interacts with the K8s API.
 */
class K8sServiceRemote extends K8sService {

  /**
   * {@inheritdoc}
   */
  public function getPods(array $params = []): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function updatePods(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function updatePodsWithoutBatch(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function createPod($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function updatePod($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function deletePod($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function getPodLogs($namespace, array $params = [], $container = NULL) {
    return '';
  }

  /**
   * {@inheritdoc}
   */
  public function getNodes(array $params = []): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function getNamespaces(array $params = []): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function createNamespace(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function updateNamespace(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function deleteNamespace(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function getMetricsPods(array $params = []): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function getMetricsNodes(array $params = []): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function updateNodes(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function updateNodesWithoutBatch(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function updateNamespaces(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function updateNamespacesWithoutBatch(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function getDeployments(array $params = []) {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function updateDeploymentsWithoutBatch(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function updateDeployments(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function createDeployment($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function updateDeployment($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function deleteDeployment($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function getReplicaSets(array $params = []): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function createReplicaSet($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function updateReplicaSet($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function deleteReplicaSet($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function updateNetworkPolicies(array $params = [], $clear = TRUE): bool {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function getNetworkPolicies(array $params = []): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function createNetworkPolicy($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function updateNetworkPolicy($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function deleteNetworkPolicy($namespace, array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function getPersistentVolumes(array $params = []): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function updatePersistentVolumes(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function updatePersistentVolumesWithoutBatch(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function createPersistentVolume(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function updatePersistentVolume(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function deletePersistentVolume(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function getClusterRoles(array $params = []): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function updateClusterRoles(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function createClusterRole(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function updateClusterRole(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function deleteClusterRole(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function getClusterRoleBindings(array $params = []): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function updateClusterRoleBindings(array $params = [], $clear = TRUE): bool {
    return TRUE;
  }

  /**
   * {@inheritdoc}
   */
  public function createClusterRoleBinding(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function updateClusterRoleBinding(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * {@inheritdoc}
   */
  public function deleteClusterRoleBinding(array $params = []): array {
    $this->saveOperation(__FUNCTION__, func_get_args());
    return ['SendToWorker' => TRUE];
  }

  /**
   * Save operation to queue.
   *
   * @param string $operation
   *   The operation to perform.
   * @param array $params
   *   An array of parameters.
   */
  private function saveOperation(string $operation, array $params): void {
    if (empty($this->cloudContext)) {
      return;
    }

    $cloud_config = $this->cloudConfigPluginManager->loadConfigEntity();
    if (!$cloud_config->isRemote()) {
      return;
    }

    $queue = $this->queueFactory->get('operation_queue_' . $cloud_config->get('cloud_cluster_name')->value . $cloud_config->get('cloud_cluster_worker_name')->value);
    $queue->createItem([
      'cloud_context' => $this->cloudContext,
      'operation' => $operation,
      'params' => $params,
      'service_name' => 'k8s',
    ]);
  }

}
